%% @author author <author@example.com>
%% @copyright YYYY author.

%% @doc TEMPLATE.

-module(skel).
-author('author <author@example.com>').
-export([start/0, start_link/0, stop/0]).

ensure_started(App) ->
    case application:start(App) of
	ok ->
	    ok;
	{error, {already_started, App}} ->
	    ok
    end.

%% @spec start_link() -> {ok,Pid::pid()}
%% @doc Starts the app for inclusion in a supervisor tree
start_link() ->
    skel_deps:ensure(),
    ensure_started(crypto),
    ensure_started(webmachine),
    skel_sup:start_link().

%% @spec start() -> ok
%% @doc Start the skel server.
start() ->
    skel_deps:ensure(),
    ensure_started(crypto),
    ensure_started(webmachine),
    application:start(skel).

%% @spec stop() -> ok
%% @doc Stop the skel server.
stop() ->
    Res = application:stop(skel),
    application:stop(webmachine),
    application:stop(crypto),
    Res.
